import es, playerlib, popuplib, cPickle, os.path, gamethread, usermsg, services

### Start Config ###
ranks = {
	'Infinatly bad': -999,
	'Bad': -1,
	'Neutral': 1,
	'Fair': 4,
	'Good': 10,
	'Very Good': 15,
	'Excellent': 20,
	'Extremely Excellent': 25,
	'Bonbon': 30
}
### End Config ###

info = es.AddonInfo() 
info['name']        = "Karma" 
info['version']     = "1.3" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/points" 
info['description'] = "A karma system where people can vote to take/give karma" 

es.ServerVar('karma_version', info['version'], 'Karma System made by Bonbon AKA Bonbon367').makepublic()

in_progress = 0

player_data = {}

target = 0
type = 0
menu = None
yes = 0
no = 0
starter = 0

sv = es.ServerVar

sv_options = {
	'point_name': 'Karma',
	'tell_format': '#green[#lightgreenKarma#green]:#green ',
	'vote_command': '!karmavote',
	'cancel_command': '!karmacancel',
	'help_command': '!karmahelp',
	'rank_command': '!karmarank',
	'top_command': '!karmatop',
	'admin_command': '!karmaadd',
	'players_in_top': 10,
	'min_points_to_make_votes': -3,
	'vote_time': 45,
	'min_players': 1,
	'karma_admins': 'STEAM_0:0:11089864,STEAM_0:1:230943,STEAM_0:0:11089864'
}

def load():
	player_db = es.getAddonPath('points') + '/player_data.db'
	if os.path.isfile(player_db):
		global player_data
		player_stats = open(player_db)
		player_data = cPickle.load(player_stats)
		player_stats.close()
	for a in sv_options:
		es.ServerVar(a).set(sv_options[a])
	if os.path.isfile(es.getAddonPath('points') + '/points.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/points/points.cfg')
		set_vars()
		if not es.exists('saycommand', vote_command):
			es.regsaycmd(vote_command, 'points/command')
		if not es.exists('clientcommand', 'karma_vote_reason'):
			es.regclientcmd('karma_vote_reason', 'points/vote_reason')
		if not es.exists('saycommand', help_command):
			es.regsaycmd(help_command, 'points/help')
		if not es.exists('saycommand', rank_command):
			es.regsaycmd(rank_command, 'points/rank')
		if not es.exists('saycommand', top_command):
			es.regsaycmd(top_command, 'points/top')
		if not es.exists('saycommand', admin_command):
			es.regsaycmd(admin_command, 'points/admin')
		if not es.exists('saycommand', cancel_command):
			es.regsaycmd(cancel_command, 'points/cancel')
	else:
		es.dbgmsg(0, 'Script Cannot Function, no Config')

def unload():
	if es.exists('saycommand', command):
		es.unregsaycmd(command)
	save_stuff()
	for a in [vote_command, help_command, rank_command, top_command, admin_command, cancel_command]:
		if es.exists('saycommand', a):
			es.unregsaycmd(a)
	if es.exists('karma_vote_reason'):
		es.unregclientcmd('karma_vote_reason')

def set_vars():
	global point_name, tell_format, help_command, vote_command, cancel_command, rank_command, top_command, admin_command, players_in_top, min_points_to_make_votes, vote_time, min_players, admins
	point_name = str(sv('point_name'))
	tell_format = str(sv('tell_format'))
	vote_command = str(sv('vote_command'))
	cancel_command = str(sv('cancel_command'))
	help_command = str(sv('help_command'))
	rank_command = str(sv('rank_command'))
	top_command = str(sv('top_command'))
	admin_command = str(sv('admin_command'))
	players_in_top = int(sv('players_in_top'))
	min_points_to_make_votes = int(sv('min_points_to_make_votes'))
	vote_time = int(sv('vote_time'))
	min_players = int(sv('min_players'))
	admins = str(sv('karma_admins'))

class Vote:
	def __init__(self, userid, target):
		self.userid = userid
		self.target = target

	def make_vote(self, type, reason):
		if not in_progress:
			global in_progress, menu, yes, no, starter
			es.msg('#multi', '%s%s Has started a %s Vote'%(tell_format, self.userid[1], point_name))
			es.centermsg('%s Has started a %s Vote'%(self.userid[1], point_name))
			yes = 0
			no = 0
			menu = '%s %s\'s %s'%(type.capitalize(), self.target[1], point_name)
			votemenu = popuplib.easymenu('%s %s %s'%(type.capitalize(), self.target[1], point_name), '_popup_choice', do_points)
			votemenu.setdescription(reason)
			votemenu.addoption('Yes', 'Yes')
			votemenu.addoption('No', 'No')
			for userid in es.getUseridList():
				popuplib.send('%s %s %s'%(type.capitalize(), self.target[1], point_name), userid)
			in_progress = 1
			vtime = vote_time
			self.type = type
			gamethread.delayed(1, self.update_vote, (vtime, len(es.getUseridList())))
			starter = self.userid[0]
	
	def update_vote(self, vtime, players):
		if vtime > 0 and yes + no < players:
			vtime -= 1
			for userid in es.getUseridList():
				usermsg.hudhint(userid, '%s -- %s seconds [%s/%s]\n Yes: %s\nno: %s'%(point_name, vtime, yes + no, players, yes, no))
			gamethread.delayedname(1, 'update_vote', self.update_vote, (vtime, players))
		else:
			self.stop_vote()

	def stop_vote(self):
		global in_progress
		in_progress = 0
		if no > yes:
			es.msg('#multi', '%s%s Has not %s any %s'%(tell_format, self.target[1], 'Gained' if self.type.lower() == 'give' else 'Lost', point_name))
		elif no < yes:
			global player_data
			es.msg('#multi', '%s%s Has %s 1 %s'%(tell_format, self.target[1], 'Gained' if self.type.lower() == 'give' else 'Lost', point_name))
			player_data[self.target[0]] += 1 if self.type == 'give' else -1
		else:
			es.msg('#multi', '%sIt was a tie, no action will be taken!'%tell_format)
			self.close_menus()

	def close_menus(self):
		for userid in es.getUseridList():
			count = popuplib.active(userid)['count']
			while count:
				count -= 1
				popuplib.close(popuplib.active(userid)['name'], userid)
	
	def cancel_vote(self):
		if self.userid[0] == starter or self.userid[0] in admins or self.userid[0] in str(es.ServerVar('BASIC_AUTH_ADMIN_LIST')):
			global in_progress
			in_progress = 0
			gamethread.cancelDelayed('update_vote')
			es.msg('#multi', '%sVote was canceled!'%tell_format)
			self.close_menus()

class Player:
	def __init__(self, userid=None):
		self.userid = userid
		if es.exists('userid', userid):
			self.steamid = es.getplayersteamid(userid)
	
	def return_rank(self, points):
		a = sorted(ranks.iteritems(), key=lambda (k, v): (v, k))
		b = None
		for c in a:
			if points >= c[1]:
				b = c[0]
		return b

	def check_player(self):
		if not player_data.has_key(es.getplayersteamid(self.userid)):
			global player_data
			player_data[es.getplayersteamid(self.userid)] = 0
			es.tell(self.userid, '#multi', '%sWelcome to our server, we have %s running type #lightgreen%s#green for help'%(tell_format, point_name, help_command))

	def return_rank_number(self):
		place = 1
		d = sorted(player_data.iteritems(), key=lambda (k, v): (v, k), reverse=True)
		for a in d:
			if str(es.getuserid(a[0])) == str(self.userid):
				return place
			place += 1

	def is_authed(self):
		if self.steamid in admins:
			return 1
		elif self.steamid in return_admins() and 'mani_admins' in str(es.ServerVar('karma_admins')):
			return 1
		elif isAuthed(self.userid):
			return 1
		return 0

def setup_auth(): # Thanks, SD
	global isAuthed
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
		auth_service.registerCapability('test_auth', auth_service.ADMIN)
		isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'karma_admin')
	else:
		isAuthed = lambda x: False

def save_stuff():
	player_db = open(es.getAddonPath('points') + '/player_data.db', 'w')
	cPickle.dump(player_data, player_db)
	player_db.close()

def round_end(ev):
	save_stuff()

def command():
	userid = es.getcmduserid()
	if len(es.getUseridList()) >= min_players:
		Player(userid).check_player()
		if not in_progress:
			if player_data[playerlib.getPlayer(userid).get('steamid')] >= min_points_to_make_votes:
				vm = popuplib.easymenu('Select Player', '_popup_choice', chose_point)
				for a in es.getUseridList():
					vm.addoption(a, playerlib.getPlayer(a).get('name'))
				popuplib.send('Select Player', userid)
			else:
				es.tell(userid, '#multi', '%sYou do not have enough %s to vote to give/take other peoples %s!'%(tell_format, point_name, point_name))
		else:
			es.tell(userid, '#multi', '%sThere is already a vote in progress!'%tell_format)
	else:
		es.tell(userid, '#multi', '%sThere are not enough people!'%tell_format)

def help():
	userid = es.getcmduserid()
	es.tell(userid, '#multi', '%sType #lightgreen%s#green to start a vote. To see your rank type #lightgreen%s'%(tell_format, vote_command, rank_command))
	es.tell(userid, '#multi', '%sType #lightgreen%s#green to see the top'%(tell_format, top_command))

def vote_reason():
	userid = es.getcmduserid()
	if es.getargc() > 1:
		if es.exists('userid', target):
			Vote([es.getplayersteamid(userid), es.getplayername(userid)], [es.getplayersteamid(target), es.getplayername(target)]).make_vote(type, es.getargs())

def rank():
	userid = es.getcmduserid()
	Player(userid).check_player()
	es.msg('#multi', '%s%s is ranked %s/%s with %s and karma level is #lightgreen%s'%(tell_format, es.getplayername(userid), Player(userid).return_rank_number(), len(player_data), player_data[es.getplayersteamid(userid)], Player(userid).return_rank(player_data[es.getplayersteamid(userid)])))

def top():
	userid = es.getcmduserid()
	t___t = players_in_top
	top = popuplib.easymenu('Top', '_popup_choice', top_select)
	d = sorted(player_data.iteritems(), key=lambda (k, v): (v, k), reverse=True)
	for e in d:
		t___t -=1
		if t___t >= 0:
				top.addoption(e[0], '%s: %s'%(es.getplayername(es.getuserid(e[0])) if es.getuserid(e[0]) else e[0], int(player_data[e[0]])))
	popuplib.send('Top', userid)

def chose_point(userid, choice, popupid):
	if not int(userid) == int(choice):
		if es.exists('userid', choice):
			pm = popuplib.easymenu('Take Or Give?', '_popup_choice', chose_reason)
			pm.addoption([choice, 'give'], 'Give')
			pm.addoption([choice, 'take'], 'Take')
			popuplib.send('Take Or Give?', userid)
		else:
			es.tell(userid, '#multi', '%sSorry, player has left the server'%tell_format)
	else:
		es.tell(userid, '#multi', '%sThat\'s not the way it works...'%tell_format)

def chose_reason(userid, choice, popupid):
	if es.exists('userid', choice[0]):
		global target, type
		type = choice[1].lower()
		target = choice[0]
		es.tell(userid, '#multi', '%sPress escape to chose a reason'%tell_format)
		es.escinputbox(30, userid, 'Chose A Reason', 'Please Input a reason', 'karma_vote_reason')
	else:
		es.tell(userid, '#multi', '%sSorry, player has left the server'%tell_format)

def do_points(userid, choice, popupid):
	global yes, no
	es.msg('#multi', '%s%s voted %s'%(tell_format, playerlib.getPlayer(userid).get('name'), choice))
	if choice == 'Yes':
		yes += 1
	elif choice == 'No':
		no += 1

def player_activate(ev):
	Player(ev['userid']).check_player()

def top_select(userid, choice, popupid):
	message = '%s%s has #lightgreen%s#green and is a #lightgreen%s'%(tell_format, es.getplayername(es.getuserid(choice)) if es.getuserid(choice) else choice, player_data[choice], Player().return_rank(player_data[choice]))
	es.tell(userid, '#multi', message)

def return_admins():
	if os.path.is_file(es.getAddonPath('clients').replace('addons/eventscripts/clients', 'cfg/mani_admin_plugin/clients.txt')):
		admins = []
		a = open(es.getAddonPath('clients').replace('addons/eventscripts/clients', 'cfg/mani_admin_plugin/clients.txt'), 'r')
		b = a.readlines()
		a.close()
		c = []
		for a in b:
			a = a.replace('\t', '').replace(' ', '')
			if not a.startswith('//'):
				c.append(a)
		for a in c:
			if a.lower().startswith('"steam""steam_0:'):
				admins.append(a.lower().replace('"steam""', '').replace('"', '').replace('\n', '').upper())
		return admins

def admin():
	userid = es.getcmduserid()
	if Player(userid).is_authed():
		if es.getargc() > 1:
			args = es.getargs().split(' ')
			if len(args) >= 3:
				target = es.getuserid(args[1])
				if target:
					amount = args[2]
					if amount.isdigit():
						global player_data
						amount = int(amount)
						steamid = es.getplayersteamid(target)
						player_data[steamid] += amount if args[0].lower() == 'give' else -amount
						es.tell(target, '#multi', '%sAn admin has given you #lightgreen%s#green %s'%(tell_format, amount, point_name))
						es.tell(userid, '#multi', '%sYou have %s #lightgreen%s %s #green%s'%(tell_format, '%sn'%args[0], es.getplayername(target), amount, point_name))
					es.tell(userid, '#multi', '%sInvalid amount'%tell_format)
			else:
				es.tell(userid, '#multi', '%sInvalid Syntax -- #lightgreen%s <take/give> <player> <amount>'%(tell_format, admin_command))
		else:
			es.tell(userid, '#multi', '%sInvalid Syntax -- #lightgreen%s <take/give> <player> <amount>'%(tell_format, admin_command))

def cancel():
	userid = es.getcmduserid()
	Vote([es.getplayersteamid(userid), None], [None, None]).cancel_vote()

setup_auth()
